## lomiri-content-hub 2.1.0

=== CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

cmake_minimum_required(VERSION 3.5)

project(lomiri-content-hub VERSION 2.1.0)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

option(ENABLE_TESTS "Build tests" ON)
option(ENABLE_DOC "Build documentation" ON)
option(ENABLE_UBUNTU_COMPAT "Enable Ubuntu.Content QML compatibility layer" OFF)
option(ENABLE_QT6 "Enable building with Qt6" OFF)
option(ENABLE_WERROR "Enable -Werror" OFF)
option(ENABLE_COVERAGE "Enable coverage reporting" ON)

if (ENABLE_QT6 AND ENABLE_UBUNTU_COMPAT)
    message (FATAL_ERROR "Ubuntu QML compat (ENABLE_UBUNTU_COMPAT) mode is not available for Qt6 builds (ENABLE_QT6)!")
endif ()

if (ENABLE_QT6)
    message("Building with Qt6")
    set(QT_VERSION_MAJOR 6)
    set(QT_SUFFIX "-qt6")
else()
    message("Building with Qt5")
    set(QT_VERSION_MAJOR 5)
endif()
find_package(QT NAMES Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui DBus Quick)

include (GNUInstallDirs)
find_package(GSettings)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC -pthread")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -fno-strict-aliasing -fPIC -pthread -Wno-unused-function -Wall -Wextra -pedantic")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

if (ENABLE_WERROR)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

set(pkglibexecdir "${CMAKE_INSTALL_FULL_LIBEXECDIR}")

set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS
    Core
    Gui
    DBus
    Quick
)

find_package(PkgConfig REQUIRED)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(GIO REQUIRED gio-unix-2.0)
pkg_check_modules(LOMIRI_LAUNCH REQUIRED lomiri-app-launch-0)
if (ENABLE_QT6)
    pkg_check_modules(GSETTINGS REQUIRED gsettings-qt6)
    pkg_check_modules(LOMIRI_DOWNLOAD_MANAGER REQUIRED lomiri-download-manager-client-qt6)
else()
    pkg_check_modules(GSETTINGS REQUIRED gsettings-qt)
    pkg_check_modules(LOMIRI_DOWNLOAD_MANAGER REQUIRED lomiri-download-manager-client)
endif()
pkg_check_modules(LOMIRI_API REQUIRED liblomiri-api)
pkg_check_modules(DBUS REQUIRED dbus-1)
pkg_check_modules(NOTIFY REQUIRED libnotify)
pkg_check_modules(APPARMOR REQUIRED libapparmor)

pkg_check_modules(LIBERTINE libertine)
if(LIBERTINE_FOUND)
   message("Building with libertine support")
else()
   message(WARNING "Building without libertine support")
endif()

add_definitions(-DDEBUG_ENABLED)

set(GETTEXT_PACKAGE "lomiri-content-hub")
add_definitions(-DI18N_DOMAIN="${GETTEXT_PACKAGE}")

set(CONTENT_HUB_VERSION_MAJOR 1)
set(CONTENT_HUB_VERSION_MINOR 0)
set(CONTENT_HUB_VERSION_PATCH 0)
set(CONTENT_HUB_VERSION "${CONTENT_HUB_VERSION_MAJOR}.${CONTENT_HUB_VERSION_MINOR}.${CONTENT_HUB_VERSION_PATCH}")

set(QML_API_VERSION_MAJOR 1)

include_directories(include)

if (${ENABLE_DOC})
  add_subdirectory(doc)
endif()
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(import)
add_subdirectory(examples)
add_subdirectory(tools)

install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/${CMAKE_LIBRARY_ARCHITECTURE}/qt${QT_VERSION_MAJOR})

# Build and install a pkg-config file
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_FULL_BINDIR})
set(libdir ${CMAKE_INSTALL_FULL_LIBDIR})
set(includedir ${CMAKE_INSTALL_FULL_INCLUDEDIR}/${CMAKE_LIBRARY_ARCHITECTURE}/qt${QT_VERSION_MAJOR})
set(pkg-name "liblomiri-content-hub${QT_SUFFIX}")
set(glib-pkg-name "liblomiri-content-hub-glib")
configure_file(liblomiri-content-hub.pc.in liblomiri-content-hub${QT_SUFFIX}.pc @ONLY)
install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/liblomiri-content-hub${QT_SUFFIX}.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)
configure_file(liblomiri-content-hub-glib.pc.in liblomiri-content-hub-glib.pc @ONLY)
install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/liblomiri-content-hub-glib.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

if (${ENABLE_TESTS})
    enable_testing()

    find_package(QT NAMES Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Test QuickTest)

    if(ENABLE_COVERAGE)

        find_package(CoverageReport)

        #####################################################################
        # Enable code coverage calculation with gcov/gcovr/lcov
        # Usage:
        #  * Switch build type to coverage (use ccmake or cmake-gui)
        #  * Invoke make, make test, make coverage
        #  * Find html report in subdir coveragereport
        #  * Find xml report feasible for jenkins in coverage.xml
        #####################################################################
        IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
            SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
            SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
            SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
        ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

    endif()

    add_subdirectory(tests)

    # There's no nice way to format this. Thanks CMake.
    add_test(LGPL-required
        /bin/sh -c "! grep -rl 'GNU General' ${PROJECT_SOURCE_DIR}/src/client ${PROJECT_SOURCE_DIR}/include/client ${PROJECT_SOURCE_DIR}/src/shared ${PROJECT_SOURCE_DIR}/include/shared"
    )
    add_test(GPL-required
        /bin/sh -c "! grep -rl 'GNU Lesser' ${PROJECT_SOURCE_DIR}/src/server ${PROJECT_SOURCE_DIR}/include/server ${PROJECT_SOURCE_DIR}/include/test ${PROJECT_SOURCE_DIR}/tests ${PROJECT_SOURCE_DIR}/examples"
    )
endif()

=== tests/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

find_package(GMock REQUIRED)

add_definitions(-DQT_NO_KEYWORDS)

include_directories (
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_SOURCE_DIR}/src/com/lomiri/content
  ${GIO_INCLUDE_DIRS}
  ${LIBERTINE_INCLUDE_DIRS}
  ${LOMIRI_LAUNCH_INCLUDE_DIRS}
  ${CMAKE_BINARY_DIR}/src
  ${CMAKE_BINARY_DIR}/src/com/lomiri/content
  ${GMOCK_INCLUDE_DIR}
)

add_subdirectory(acceptance-tests)
add_subdirectory(qml-tests)
add_subdirectory(peers)

if (ENABLE_UBUNTU_COMPAT)
  add_subdirectory(qml-tests-ubuntu-compat)
endif()

=== examples/exporter/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  exporter

  exporter.cpp
  exampleexporter.cpp
)

target_link_libraries(exporter Qt::Core Qt::Gui Qt::DBus)

set_target_properties(
  exporter
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  exporter

  lomiri-content-hub${QT_SUFFIX}
)

=== examples/pasteboard/CMakeLists.txt ===
# Copyright © 2016 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  copy-to-pasteboard

  copy.cpp
)

target_link_libraries(copy-to-pasteboard Qt::Core Qt::Gui Qt::DBus)

set_target_properties(
  copy-to-pasteboard
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  copy-to-pasteboard
  lomiri-content-hub${QT_SUFFIX}
)

add_executable(
  paste-from-pasteboard

  paste.cpp
)

target_link_libraries(paste-from-pasteboard Qt::Core Qt::Gui Qt::DBus)

set_target_properties(
  paste-from-pasteboard
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  paste-from-pasteboard
  lomiri-content-hub${QT_SUFFIX}
)

=== src/com/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

add_subdirectory(lomiri)

=== tests/acceptance-tests/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

project(test CXX C)

qt_wrap_cpp(MOCS test_harness.h)
add_custom_target(generated_test_harness DEPENDS ${MOCS})

set(TESTS
  app_hub_communication_default_source
  app_hub_communication_known_sources
  app_hub_communication_stores
  app_hub_communication_store_migration
  app_hub_communication_transfer
  app_hub_communication_paste
  app_hub_communication_handler
  test_utils
  test_types
  mimedata_test
  glib_test
)

set(TEST_LIBS
  ${GMOCK_LIBRARIES}
  ${GTEST_BOTH_LIBRARIES}
  lomiri-content-hub${QT_SUFFIX}
)

foreach(test ${TESTS})
  # set the sources per test
  set(${test}_SOURCES
    ${test}.cpp
    ${MOCS}
  )

  # set targets, linked libs and test
  add_executable(${test}
    ${${test}_SOURCES}
  )
  find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Test)
  target_link_libraries(${test} Qt::Core Qt::Gui Qt::DBus Qt::Test)

  target_link_libraries(${test}
    ${TEST_LIBS}
  )

  add_dependencies(${test} transfer_files generated_test_harness)

  add_test(NAME ${test} COMMAND dbus-test-runner --task ${CMAKE_CURRENT_BINARY_DIR}/${test})

  SET_TESTS_PROPERTIES(${test}
    PROPERTIES ENVIRONMENT "LOMIRI_CONTENT_HUB_TESTING=1")
endforeach(test)

add_executable(
  test_registry_updater
  test_registry_updater.cpp
  ${MOCS}
  ${CMAKE_SOURCE_DIR}/src/com/lomiri/content/service/registry-updater.cpp
  ${CMAKE_SOURCE_DIR}/src/com/lomiri/content/service/registry.cpp
  good.json
  bad.json
  source_all.json
)

target_link_libraries(test_registry_updater Qt::Core Qt::Gui Qt::DBus Qt::Test)
target_link_libraries(test_registry_updater ${TEST_LIBS} ${GSETTINGS_LDFLAGS})
add_test(NAME test_registry_updater COMMAND dbus-test-runner --task ${CMAKE_CURRENT_BINARY_DIR}/test_registry_updater)

SET_TESTS_PROPERTIES(test_registry_updater
  PROPERTIES ENVIRONMENT "LOMIRI_CONTENT_HUB_TESTING=1")

set_target_properties(
  test_registry_updater
  PROPERTIES
  AUTOMOC TRUE
)

file(COPY good.json bad.json source_all.json DESTINATION .)

target_link_libraries(glib_test lomiri-content-hub-glib)

add_custom_target(
  transfer_files
  COMMENT "Generating transfer test files"
  COMMAND ${CMAKE_COMMAND} -E touch file1 file2 file3
)

=== tests/qml-tests-ubuntu-compat/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(TEST tst_QmlTests_UbuntuCompat)
set(XVFB_CMD xvfb-run -a -s "-screen 0 640x480x24")
add_executable(${TEST} ../qml-tests/tst_QmlTests.cpp)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Qml Quick Test QuickTest)
target_link_libraries(${TEST} Qt::Core Qt::Qml Qt::Quick Qt::Test Qt::QuickTest)
add_test(NAME ${TEST} COMMAND ${XVFB_CMD} dbus-test-runner --task ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
set_tests_properties(${TEST} PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal;QML2_IMPORT_PATH=${CMAKE_BINARY_DIR}/import;APP_ID=com.some.app.for.testing")

set(out_qml_files)
file(GLOB qmlTestFiles RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/../qml-tests ../qml-tests/*.qml)
foreach(qmlTestFile ${qmlTestFiles})
  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${qmlTestFile}
                      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../qml-tests/${qmlTestFile}
                      COMMAND sed -e 's/Lomiri.Content/Ubuntu.Content/g' ${CMAKE_CURRENT_SOURCE_DIR}/../qml-tests/${qmlTestFile} >${CMAKE_CURRENT_BINARY_DIR}/${qmlTestFile})
endforeach(qmlTestFile)
add_custom_target(copy_qml_test_ubuntu_compat_files_to_build_dir DEPENDS ${qmlTestFiles})
add_dependencies(${TEST}
  lomiri-content-hub-plugin
  copy_ubuntu_compat_files_to_build_dir
  copy_qml_test_ubuntu_compat_files_to_build_dir
)

=== tests/qml-tests/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(TEST tst_QmlTests)
set(XVFB_CMD xvfb-run -a -s "-screen 0 640x480x24")
add_executable(${TEST} tst_QmlTests.cpp)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Qml Quick Test QuickTest)
target_link_libraries(${TEST} Qt::Core Qt::Qml Qt::Quick Qt::Test Qt::QuickTest)
add_test(NAME ${TEST} COMMAND ${XVFB_CMD} dbus-test-runner --task ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
set_tests_properties(${TEST} PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal;QML2_IMPORT_PATH=${CMAKE_BINARY_DIR}/import;APP_ID=com.some.app.for.testing")

# copy qml files under test to build dir
set(out_qml_files)
if(NOT ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  # copy qml test files to build dir
  file(GLOB qmlTestFiles RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.qml)
  foreach(qmlTestFile ${qmlTestFiles})
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${qmlTestFile}
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${qmlTestFile}
                       COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${qmlTestFile} ${CMAKE_CURRENT_BINARY_DIR}/${qmlTestFile})
  endforeach(qmlTestFile)
  add_custom_target(copy_qml_test_files_to_build_dir DEPENDS ${qmlTestFiles})
  add_dependencies(${TEST} copy_qml_test_files_to_build_dir)
endif()

=== import/Lomiri/Content/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

project(lomiri-content-hub-plugin)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS
  Quick
)

set(CMAKE_AUTOMOC TRUE)

set(QT_IMPORTS_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml")
set(CONTENT_HUB_IMPORTS_DIR "${QT_IMPORTS_DIR}/Lomiri/Content")

set(PLUGIN lomiri-content-hub-plugin)

add_definitions(-DQT_NO_KEYWORDS)

if (ENABLE_UBUNTU_COMPAT)
    add_definitions(-DENABLE_UBUNTU_COMPAT)
endif ()

include_directories(
    ${CMAKE_SOURCE_DIR}
    ${LOMIRI_API_INCLUDE_DIRS}
    ${DBUS_INCLUDE_DIRS}
    ${GLIB_INCLUDE_DIRS}
    ${LOMIRI_LAUNCH_INCLUDE_DIRS}
)

set(PLUGIN_HDRS
    contenthandler.h
    contenthub.h
    contenthubplugin.h
    contenticonprovider.h
    contentitem.h
    contentpeer.h
    contentpeermodel.h
    contentscope.h
    contentstore.h
    contenttransfer.h
    contenttype.h
    qmlimportexporthandler.h
    )

set(PLUGIN_SRC
    contenthandler.cpp
    contenthub.cpp
    contenthubplugin.cpp
    contenticonprovider.cpp
    contentitem.cpp
    contentpeer.cpp
    contentpeermodel.cpp
    contentscope.cpp
    contentstore.cpp
    contenttransfer.cpp
    contenttype.cpp
    qmlimportexporthandler.cpp
    ../../../src/com/lomiri/content/debug.cpp
    )

add_library(${PLUGIN} MODULE ${PLUGIN_SRC} ${PLUGIN_HDRS})

target_link_libraries(${PLUGIN} Qt::Core Qt::Qml Qt::Quick Qt::DBus)
target_link_libraries(
    ${PLUGIN}
    lomiri-content-hub${QT_SUFFIX}
    ${LOMIRI_API_LIBRARIES}
    ${GLIB_LIBRARIES}
    ${LOMIRI_LAUNCH_LDFLAGS}
)

install(TARGETS ${PLUGIN} DESTINATION ${CONTENT_HUB_IMPORTS_DIR})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/qmldir DESTINATION ${CONTENT_HUB_IMPORTS_DIR})

file(GLOB QML_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.qml qmldir)
install(FILES ${QML_FILES} DESTINATION ${CONTENT_HUB_IMPORTS_DIR})

if(NOT ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  # copy qml files and assets over to build dir to be able to import them uninstalled
  foreach(_file ${QML_FILES})
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_file}
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_file}
                       COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${_file} ${CMAKE_CURRENT_BINARY_DIR}/${_file})
  endforeach(_file)
  add_custom_target(copy_files_to_build_dir DEPENDS ${QML_FILES})
  add_dependencies(${PLUGIN} copy_files_to_build_dir)
endif()

if(NOT CMAKE_CROSSCOMPILING)
    set(CHECK_DEFAULT_PATH "")
    if (EXISTS "/etc/debian_version")
        set(CHECK_DEFAULT_PATH "NO_DEFAULT_PATH")
    endif()
    find_program(QML_PLUGIN_DUMP qmlplugindump REQUIRED
                     PATHS /usr/lib/qt${QT_VERSION_MAJOR}/bin
                     ${CHECK_DEFAULT_PATH}
    )

    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
        COMMAND ${QML_PLUGIN_DUMP} -noinstantiate -notrelocatable Lomiri.Content 1.1 ../../ > ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
        DEPENDS ${PLUGIN}
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    )

    add_custom_target(Content_generated_files ALL SOURCES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes DESTINATION ${CONTENT_HUB_IMPORTS_DIR})
endif()

=== src/com/lomiri/content/service/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

add_definitions(-DQT_NO_KEYWORDS)

if(LIBERTINE_FOUND)
   add_definitions(-DWITH_LIBERTINE)
endif()

include_directories(${CMAKE_CURRENT_BINARY_DIR})

qt_add_dbus_adaptor(
    CONTENT_SERVICE_SKELETON ${CMAKE_SOURCE_DIR}/src/com/lomiri/content/detail/com.lomiri.content.Service.xml
    detail/service.h com::lomiri::content::detail::Service)

include_directories(
  ${CMAKE_SOURCE_DIR}/src
  ${CMAKE_SOURCE_DIR}/src/com/lomiri/content
  ${GIO_INCLUDE_DIRS}
  ${GSETTINGS_INCLUDE_DIRS}
  ${LOMIRI_LAUNCH_INCLUDE_DIRS}
  ${LIBERTINE_INCLUDE_DIRS}
)

add_executable(
  lomiri-content-hub-service

  main.cpp
  registry.cpp
  registry-updater.cpp
  ../debug.cpp
  ../utils.cpp
  ${CONTENT_SERVICE_SKELETON}
)

set_target_properties(
  lomiri-content-hub-service
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(lomiri-content-hub-service Qt::Core Qt::DBus Qt::Gui)

target_link_libraries(
  lomiri-content-hub-service

  lomiri-content-hub${QT_SUFFIX}
  ${GIO_LDFLAGS}
  ${GSETTINGS_LDFLAGS}
  ${LOMIRI_LAUNCH_LDFLAGS}
  ${LIBERTINE_LDFLAGS}
)

install(
  TARGETS lomiri-content-hub-service
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

configure_file(
  com.lomiri.content.dbus.Service.service.in
  com.lomiri.content.dbus.Service.service
  @ONLY)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/com.lomiri.content.dbus.Service.service
  DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services
)

###########################
# GSettings
###########################

add_schema ("com.lomiri.content.hub.gschema.xml")

install(
  FILES xorg.png
  DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-content-hub/icons/
)

=== debian/changelog ===
lomiri-content-hub (2.1.0-4) unstable; urgency=medium

  * debian/control:
    + Add B:/R: (liblomiri-content-hub-glib-dev) relation to obsolete
      libcontent-hub-glib-dev. (Closes: #1102925).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 13 Apr 2025 21:33:19 +0200

lomiri-content-hub (2.1.0-3) unstable; urgency=medium

  [ Chris Lamb ]
  * debian/rules:
    + Use rdfind option '-makeresultsfile false' to make the documentation build
      reproducible. (Closes: #1082707).

  [ Mike Gabriel ]
  * debian/control:
    + Add B:/R: relation between lomiri-content-hub-common and obsolete content-
      hub (as found in Debian 12). (Closes: #1102682).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 12 Apr 2025 11:18:55 +0200

lomiri-content-hub (2.1.0-2) unstable; urgency=medium

  * Re-upload source-only as is.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 11 Apr 2025 06:30:44 +0200

lomiri-content-hub (2.1.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/:
    + Dually build against Qt5 and Qt6 to create client-side shared content hub
      libraries for Qt6-based Lomiri apps.
    + Add arch:all package lomiri-content-hub-common (for translations,
      gschemas, artwork, etc.).
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions for debian/.
  * debian/{control,rules}:
    + Build using dh-click.
    + Build without coverage reporting.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/rules:
    + Variable name change: CONTENT_HUB_TESTING -> LOMIRI_CONTENT_HUB_TESTING.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 09 Apr 2025 14:45:22 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DPKG_GENSYMBOLS_CHECK_LEVEL=4
export LOMIRI_CONTENT_HUB_TESTING=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/buildflags.mk

PROJECT_DH_OPTIONS = --with click

# Disable coverage reporting, enable locally for introspecting test coverage
CONFIGURE_OPTS += -DENABLE_COVERAGE=OFF

ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
  CONFIGURE_OPTS += -DENABLE_TESTS=OFF
  DEB_BUILD_PROFILES += noinsttest
endif

ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  CONFIGURE_OPTS += -DENABLE_DOC=OFF
endif

# Skip tests on architectures where tests are being flaky, timeout, etc.
TESTSKIP_ARCHITECTURES_QT6 := armhf
TESTSKIP_ARCHITECTURES_QT5 :=

%:
	dh $@ $(PROJECT_DH_OPTIONS)

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-qt6 --buildsystem=cmake -- $(CONFIGURE_OPTS) -DENABLE_QT6=ON  -DENABLE_DOC=OFF ..
	dh_auto_configure --builddirectory=build-qt5 --buildsystem=cmake -- $(CONFIGURE_OPTS) -DENABLE_QT6=OFF                  ..

override_dh_auto_build:
	dh_auto_build --builddirectory=build-qt6 --buildsystem=cmake ..
	dh_auto_build --builddirectory=build-qt5 --buildsystem=cmake ..

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (,$(filter $(DEB_HOST_ARCH),$(TESTSKIP_ARCHITECTURES_QT6)))
	dh_auto_test --builddirectory=build-qt6 --buildsystem=cmake --no-parallel ..
endif
ifeq (,$(filter $(DEB_HOST_ARCH),$(TESTSKIP_ARCHITECTURES_QT5)))
	dh_auto_test --builddirectory=build-qt5 --buildsystem=cmake --no-parallel ..
endif
endif

override_dh_auto_install:
ifneq (,$(findstring nocheck,$(DEB_BUILD_PROFILES)))
	mkdir -p debian/lomiri-content-hub-testability
endif
	dh_auto_install --builddirectory=build-qt6 --buildsystem=cmake ..
	dh_auto_install --builddirectory=build-qt5 --buildsystem=cmake ..
	dh_apparmor -plomiri-content-hub-testability --profile-name=lomiri-content-hub-testability
	mkdir -p debian/tmp/var/cache/lomiri-content-hub/peers

override_dh_install:
	rmdir debian/tmp/usr/share/doc/lomiri-content-hub/qml/html/images/
	cd debian/tmp/usr/share/doc/lomiri-content-hub/cpp/html/ && rdfind -makesymlinks true -makeresultsfile false .
	cd debian/tmp/usr/share/doc/lomiri-content-hub/cpp/html/ && symlinks -rc .
	cd debian/tmp/usr/share/doc/lomiri-content-hub/qml/html/ && rdfind -makesymlinks true -makeresultsfile false .
	cd debian/tmp/usr/share/doc/lomiri-content-hub/qml/html/ && symlinks -rc .
	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_clean:
	dh_auto_clean --builddirectory=build-qt6 --buildsystem=cmake ..
	dh_auto_clean --builddirectory=build-qt5 --buildsystem=cmake ..

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## lomiri-content-hub 2.2.0~git20250807.642a369

=== import/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(Lomiri)

if (ENABLE_UBUNTU_COMPAT)
  add_subdirectory(Ubuntu)
endif()

=== src/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

add_subdirectory(com)

=== tests/peers/CMakeLists.txt ===
# Copyright © 2014 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

add_subdirectory(exporter)
add_subdirectory(importer)
add_subdirectory(sharer)
add_subdirectory(data)

=== import/Lomiri/Content/CMakeLists.txt ===
--- 
+++ 
@@ -82,21 +82,6 @@
 )
 
 install(TARGETS ${PLUGIN} DESTINATION ${CONTENT_HUB_IMPORTS_DIR})
-install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/qmldir DESTINATION ${CONTENT_HUB_IMPORTS_DIR})
-
-file(GLOB QML_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.qml qmldir)
-install(FILES ${QML_FILES} DESTINATION ${CONTENT_HUB_IMPORTS_DIR})
-
-if(NOT ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
-  # copy qml files and assets over to build dir to be able to import them uninstalled
-  foreach(_file ${QML_FILES})
-    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_file}
-                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_file}
-                       COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${_file} ${CMAKE_CURRENT_BINARY_DIR}/${_file})
-  endforeach(_file)
-  add_custom_target(copy_files_to_build_dir DEPENDS ${QML_FILES})
-  add_dependencies(${PLUGIN} copy_files_to_build_dir)
-endif()
 
 if(NOT CMAKE_CROSSCOMPILING)
     set(CHECK_DEFAULT_PATH "")
@@ -108,8 +93,13 @@
                      ${CHECK_DEFAULT_PATH}
     )
 
+    if (ENABLE_QT6)
+        set(LOMIRI_CONTENT_VERSION 2.0)
+    else()
+        set(LOMIRI_CONTENT_VERSION 1.1)
+    endif()
     add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
-        COMMAND ${QML_PLUGIN_DUMP} -noinstantiate -notrelocatable Lomiri.Content 1.1 ../../ > ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
+        COMMAND ${QML_PLUGIN_DUMP} -noinstantiate -notrelocatable Lomiri.Content ${LOMIRI_CONTENT_VERSION} ../../ > ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
         DEPENDS ${PLUGIN}
         WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
     )
@@ -117,3 +107,5 @@
     add_custom_target(Content_generated_files ALL SOURCES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes)
     install(FILES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes DESTINATION ${CONTENT_HUB_IMPORTS_DIR})
 endif()
+
+add_subdirectory(qml${QT_VERSION_MAJOR})

=== src/com/lomiri/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

add_subdirectory(content)

=== tests/peers/data/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

install(
  FILES webbrowser-app.png clock.png Joker.vcf Stark,_Tony.vcf "Music Ringtone.ogg"
  DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-content-hub/testability/data
)

=== tests/peers/sharer/CMakeLists.txt ===
# Copyright © 2014 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  lomiri-content-hub-test-sharer

  sharer.cpp
  autosharer.cpp
)

target_link_libraries(lomiri-content-hub-test-sharer Qt::Core Qt::Gui Qt::DBus)

set_target_properties(
  lomiri-content-hub-test-sharer
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  lomiri-content-hub-test-sharer

  lomiri-content-hub${QT_SUFFIX}
)

install(
  TARGETS lomiri-content-hub-test-sharer
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  FILES lomiri-content-hub-test-sharer.json
  DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-content-hub/peers
  RENAME lomiri-content-hub-test-sharer
)

install(
  FILES lomiri-content-hub-test-sharer.desktop
  DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
)

install(
  FILES lomiri-content-hub-test-sharer.png
  DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/512x512/apps/
)

=== debian/changelog ===
lomiri-content-hub (2.2.0~git20250807.642a369-1~exp1) experimental; urgency=medium

  * Upload to experimental.

  * New upstream release preview / Git snapshot.
  * debian/{rules,watch}:
    + Adjust to packaging upstream Git snapshots for now.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 21 Sep 2025 11:16:54 +0200

=== debian/control ===
Source: lomiri-content-hub
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras,
               dbus-test-runner <!nocheck>,
               debhelper-compat (= 13),
               click-dev,
               dh-apparmor,
               doxygen <!nodoc>,
               google-mock <!nocheck>,
               libgtest-dev,
               libapparmor-dev,
               libdbus-1-dev,
               libglib2.0-dev,
               libgsettings-qt-dev,
               libgsettings-qt6-dev,
#               liblibertine-dev,
               liblomiri-api-dev,
               libnotify-dev,
               liblomiri-download-manager-client-dev,
               liblomiri-download-manager-client-qt6-dev,
               liblomiri-app-launch-dev (>= 0.1.1),
#               qml6-module-lomiri-components,
               qml6-module-qtquick <!nocheck>,
               qml6-module-qtquick-window <!nocheck>,
               qml6-module-qttest <!nocheck>,
               qml-module-lomiri-components,
               qml-module-qtquick2,
               qml-module-qttest <!nocheck>,
               qml-module-qtqml-workerscript2,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-tools-dev,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qttools5-dev-tools,
               rdfind,
               symlinks,
               xvfb <!nocheck>,
               xauth,
# The following two QMLv6 modules are only required when building on Ubuntu noble
               qml6-module-qtqml-models,
               qml6-module-qtqml-workerscript,
Standards-Version: 4.7.2
Section: misc
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-content-hub
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-content-hub.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-content-hub/

Package: lomiri-content-hub
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         lomiri-content-hub-common (>= ${source:Version}),
Replaces: content-hub (<< 2.0.0),
Breaks: content-hub (<< 2.0.0),
Description: content sharing/picking service for Lomiri
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 This package includes the content sharing service.

Package: liblomiri-content-hub1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         lomiri-content-hub-common (>= ${source:Version}),
Suggests: lomiri-content-hub
Description: content sharing/picking library for Lomiri (Qt5)
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 This package includes the content sharing libraries (Qt5).

Package: liblomiri-content-hub-qt6-1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
         lomiri-content-hub-common (>= ${source:Version}),
Suggests: lomiri-content-hub
Description: content sharing/picking library (Qt6)
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 This package includes the content sharing libraries (Qt6).

Package: liblomiri-content-hub-glib1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         lomiri-content-hub-common (>= ${source:Version}),
Suggests: lomiri-content-hub
Description: content sharing/picking library for Lomiri - GLib bindings
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 This package includes GLib bindings of the content sharing libraries.

Package: liblomiri-content-hub-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblomiri-content-hub1 (= ${binary:Version}),
         ${misc:Depends},
Breaks: libcontent-hub-dev,
Replaces: libcontent-hub-dev,
Description: content sharing development files (Qt5)
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 This package contains the Qt5 development headers of the library.

Package: liblomiri-content-hub-qt6-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblomiri-content-hub-qt6-1 (= ${binary:Version}),
         ${misc:Depends},
Description: content sharing development files (Qt6)
 All the development headers and libraries for the content hub
 .
 This package contains the Qt6 development headers of the library.

Package: liblomiri-content-hub-glib-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblomiri-content-hub-glib1 (= ${binary:Version}),
         ${misc:Depends},
Breaks: libcontent-hub-glib-dev,
Replaces: libcontent-hub-glib-dev,
Description: content sharing development files for Lomiri - GLib bindings
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 GLib bindings of the development headers and libraries for the content hub

Package: qml-module-lomiri-content
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: liblomiri-content-hub1,
         qml-module-qtquick2,
         ${misc:Depends},
         ${shlibs:Depends},
Multi-Arch: same
Description: QML binding for Lomiri's liblomiri-content-hub (Qt5)
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 QML bindings for liblomiri-content-hub (Qt5)

Package: qml6-module-lomiri-content
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: qml6-module-qtquick,
         ${misc:Depends},
         ${shlibs:Depends},
Description: QML binding for Lomiri's liblomiri-content-hub (Qt6)
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 QML bindings for liblomiri-content-hub (Qt6)

Package: liblomiri-content-hub-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
Multi-Arch: foreign
Description: Documentation files for Lomiri's liblomiri-content-hub-dev
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 Documentation files for the liblomiri-content-hub development

Package: qml-module-lomiri-content-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
Multi-Arch: foreign
Description: Documentation files for QML module Lomiri Content
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 Documentation files for QML development.

Package: lomiri-content-hub-testability
Architecture: any
Build-Profiles: <!noinsttest>
Depends: ${misc:Depends},
         ${shlibs:Depends},
         lomiri-content-hub,
Replaces: content-hub-testability (<< 2.0.0),
Breaks: content-hub-testability (<< 2.0.0),
Provides: content-hub-testability (= ${binary:Version}),
Description: content sharing testability for Lomiri
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 Files and utilities needed for automated testing of content-hub

Package: lomiri-content-hub-common
Multi-Arch: foreign
Architecture: all
Depends: ${misc:Depends},
Replaces: lomiri-content-hub (<< 2.1.0),
 content-hub,
Breaks: lomiri-content-hub (<< 2.1.0),
 content-hub,
Description: Lomiri Content Hub - common files
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 This package contains common files such as translations.

=== debian/rules ===
--- 
+++ 
@@ -69,5 +69,40 @@
 	dh_auto_clean --builddirectory=build-qt6 --buildsystem=cmake ..
 	dh_auto_clean --builddirectory=build-qt5 --buildsystem=cmake ..
 
-get-orig-source:
-	uscan --noconf --force-download --rename --download-current-version --destdir=..
+include /usr/share/dpkg/pkg-info.mk
+
+PKD   = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
+PKG   = $(DEB_SOURCE)
+UVER  = $(shell echo $(DEB_VERSION) | cut -d "-" -f1)
+DTYPE =
+VER  ?= $(subst $(DTYPE),,$(UVER))
+
+UURL = https://gitlab.com/ubports/development/core/lomiri-content-hub.git
+UREV = $(shell echo $(VER) | cut -d"." -f4)
+
+## http://wiki.debian.org/onlyjob/get-orig-source
+.PHONY: get-orig-source
+get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
+	@
+
+$(PKG)_$(VER)$(DTYPE).orig.tar.xz: $(info I: GIT Revision=$(UREV))
+	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
+	@echo "# Downloading..."
+	git clone $(UURL) $(PKG)-$(VER) \
+	   || $(RM) -r $(PKG)-$(VER)
+	cd $(PKG)-$(VER) \
+	   && git checkout "$(UREV)" \
+	   && ( echo "# Generating ChangeLog..." \
+	      ; git --no-pager log --format="%ai %aN (%h) %n%n%x09*%w(68,0,10) %s%n" > ChangeLog \
+	      ; touch -d "$$(git log -1 --format='%ci')" ChangeLog) \
+	   && echo "# Setting times..." \
+	   && for F in $$(git ls-tree -r --name-only HEAD); do touch --no-dereference -d "$$(git log -1 --format="%ai" -- $$F)" "$$F"; done \
+	   && echo "# Cleaning-up..." \
+	   && rm -rf debian \
+	   && rm -rf src/Ubuntu \
+	   && rm -rf test/autopilot \
+	   && rm -rf .git .git*
+	@echo "# Packing..."
+	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
+	   | XZ_OPT="-6v" tar -caf "../$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
+	   && $(RM) -r "$(PKG)-$(VER)"

=== debian/tests/control ===
# Temporarily disable aa-check test until SO_PEERSEC is fixed (see #1092591)
#Tests: url-dispatcher aa-check
Tests: url-dispatcher
Depends: lomiri-content-hub-testability, dbus-daemon, xauth, xvfb, lomiri-app-launch
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,  pretty=2.2.0~git%cd.%h" \
https://gitlab.com/ubports/development/core/lomiri-content-hub.git heads/personal/gberh/luitk-qt6 debian uupdate
